#include <algorithm>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int Z;
  cin >> Z;
  while (Z--) {
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
      cin >> v[i];
    vector<pair<pair<int, int>,int>> queries(q);
    for (int i = 0; i < q; ++i) {
      cin >> queries[i].first.first >> queries[i].first.second;
      queries[i].second = i;
    }

    vector<int> prev_min(n), prev_max(n);
    prev_min[0] = prev_max[0] = -1;
    for (int i = 1; i < n; ++i) {
      prev_min[i] = i - 1;
      while (prev_min[i] != -1 && v[prev_min[i]] >= v[i])
        prev_min[i] = prev_min[prev_min[i]];
      prev_max[i] = i - 1;
      while (prev_max[i] != -1 && v[prev_max[i]] <= v[i])
        prev_max[i] = prev_max[prev_max[i]];
    }

    vector<pair<pair<int, int>, int>> points;

    for (int i = 0; i < n; ++i) {
      vector<int> breakpoints;
      breakpoints.push_back(i);
      for (int j = prev_min[i]; j != -1; j = prev_min[j])
        breakpoints.push_back(j);
      for (int j = prev_max[i]; j != -1; j = prev_max[j])
        breakpoints.push_back(j);
      sort(breakpoints.begin(), breakpoints.end());
      reverse(breakpoints.begin(), breakpoints.end());
      breakpoints.push_back(-1);
      int curr_min = v[i], curr_max = v[i];
      for (int j = 0; j + 1 < breakpoints.size(); ++j) {
        curr_min = min(curr_min, v[breakpoints[j]]);
        curr_max = max(curr_max, v[breakpoints[j]]);
        points.push_back(make_pair(make_pair(curr_min, curr_max), breakpoints[j] - breakpoints[j + 1]));
      }
    }

    sort(queries.begin(), queries.end());
    sort(points.begin(), points.end());
    reverse(queries.begin(), queries.end());
    reverse(points.begin(), points.end());
    const int T = 1024 * 1024;
    vector<int64_t> tree(2 * T);
    vector<int64_t> output(q);
    int points_it = 0;
    for (auto query : queries) {
      while (points_it < points.size() && points[points_it].first.first >= query.first.first) {
        for (int a = T + points[points_it].first.second; a > 0; a /= 2)
          tree[a] += points[points_it].second;
        ++points_it;
      }
      int64_t sum = 0;
      for (int a = T + query.first.second; a > 1; a /= 2) {
        if (a > T) sum += tree[a];
        if (a % 2 == 1) sum += tree[a - 1];
      }
      output[query.second] = sum;
    }
    for (int64_t x : output)
      cout << x << endl;
  }
}
