#include <bits/stdc++.h>

using namespace std;


const int M = 1000 * 1000 + 1;

struct ITree {
    typedef long long val_t;

    vector <val_t> T;
    int p = 1;

    ITree(int n) {
        while (p < n) p *= 2;
        T.resize(2 * p - 1,0);
    }

    int par(int x) { return (x - 1) / 2; }

    void add(int l, val_t v) {
        l += p-1;
        T[l] += v;

        while (l > 0) {
            l = par(l);
            T[l] += v;
        }
    }

    val_t query(int l, int r) {
        l += p-1; r += p-1;

        val_t ans = T[l];
        if (l < r) ans += T[r];

        while (par(l) != par(r)) {
            if (l % 2 == 1) ans += T[l+1];
            if (r % 2 == 0) ans += T[r-1];

            l = par(l);
            r = par(r);
        }

        return ans;
    }
};

struct event {
    bool query;
    int r, id, cnt;
};

vector <long long> solve(int n, int k, vector <int> &vec, vector <pair<int,int>> &queries) {
    vector <pair<int,int>> incr, decr;

    vector <vector<event>> events(M);

    for (int i = 0; i < k; i++) {
        auto q = queries[i];
        events[q.first].push_back({true, q.second, i, -1});
    }

    for (int l = n - 1; l >= 0; l--) {
        while (!incr.empty() && incr.back().second <= vec[l]) {
            incr.pop_back();
        }

        incr.push_back({l, vec[l]});

        while (!decr.empty() && decr.back().second >= vec[l]) {
            decr.pop_back();
        }

        decr.push_back({l, vec[l]});

        vector <pair<int,int>> chgPts(incr.size() + decr.size());
        merge(incr.rbegin(), incr.rend(), decr.rbegin(), decr.rend(), chgPts.begin());

        chgPts.push_back({n, 0});

        int mn = vec[l], mx = vec[l];
        int start = l;

        for (auto &e : chgPts) {
            int r, value;
            tie(r, value) = e;

            if (start < r) {
                int cnt = r - start;
                events[mn].push_back({false, mx, -1, cnt});

                start = r;
            }

            mn = min(mn, value);
            mx = max(mx, value);
        }
    }

    vector <long long> ans(k, 0);

    ITree tree(M);

    for (int l = M - 1; l >= 0; l--) {
        for (auto &e : events[l]) if (!e.query) {
            tree.add(e.r, e.cnt);
        }

        for (auto &e : events[l]) if (e.query) {
            ans[e.id] = tree.query(l, e.r);
        }
    }

    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        int n, k;
        cin >> n >> k;

        vector <int> vec(n);
        for (int &x : vec) {
            cin >> x;
        }

        vector <pair<int,int>> queries(k);
        for (auto &q : queries) {
            cin >> q.first >> q.second;
        }

        auto ans = solve(n, k, vec, queries);

        for (long long &x : ans) {
            cout << x << '\n';
        }
    }

    return 0;
}
